LIBRARY ieee  ; 
USE ieee.numeric_std.all  ; 
USE ieee.std_logic_1164.all  ; 
USE ieee.std_logic_unsigned.all  ;
USE ieee.std_logic_1164.std_logic; 
USE ieee.std_logic_arith.ALL;
  
ENTITY receiver_top_tb  IS 
  GENERIC (
    min_count  : natural   := 0 ;  
    max_count  : natural   := 50000 ); 
END ; 
 
ARCHITECTURE receiver_top_tb_arch OF receiver_top_tb IS
  SIGNAL coe_data   :  std_logic_vector (7 downto 0)  ; 
  SIGNAL reset_n   :  std_logic  ; 
  SIGNAL clk   :  std_logic  ; 
  SIGNAL coe_led   :  std_logic_vector (7 downto 0)  ; 
  SIGNAL coe_receiver   :  std_logic  ; 
  

  constant clk_period:time:=20ns;
  COMPONENT receiver_top  
    GENERIC ( 
      min_count  : natural ; 
      max_count  : natural  );  
    PORT ( 
      coe_data  : out std_logic_vector (7 downto 0) ; 
      reset_n  : in std_logic ; 
      clk  : in std_logic ; 
      coe_led  : out std_logic_vector (7 downto 0) ; 
      coe_receiver  : in std_logic ); 
  END COMPONENT ; 
BEGIN
  DUT  : receiver_top  
    GENERIC MAP ( 
      min_count  => min_count  ,
      max_count  => max_count   )
    PORT MAP ( 
      coe_data   => coe_data  ,
      reset_n   => reset_n  ,
      clk   => clk  ,
      coe_led   => coe_led  ,
      coe_receiver   => coe_receiver   ) ; 
      
      clk_time:process
      begin
        clk<='0';
        wait for clk_period/2;
        clk<='1';
        wait for clk_period/2;
    end process;
    
    stim_proc:process
    begin
      reset_n<='1';
      coe_receiver<='1';
      wait for 500000ns;
      coe_receiver<='0';
      wait for 390000ns;
      coe_receiver<='1';
      wait for 500000 ns;
      coe_receiver<='0';
      wait for 500000 ns;
      coe_receiver<='1';
      wait for  500000ns;
      coe_receiver<='0';
      wait for 499999ns;
      coe_receiver<='1';
      wait for 500000ns;
      coe_receiver<='0';
      wait for 500001 ns;
      coe_receiver<='1';
      wait for 500000ns;
      coe_receiver<='0';
      wait for 800001 ns;
      coe_receiver<='1';
      wait for 500000ns;
      coe_receiver<='0';
      wait for 1000001 ns;
      coe_receiver<='1';
      wait for 500000ns;
      wait;
      end process;
END ; 

